#!/bin/sh
USBDAEMON_INSTALL_DIR=/opt/sentinel/sud/usb
#!/bin/sh
USBDAEMON_INSTALL_DIR=/opt/sentinel/sud/usb
PROG_NAME=/opt/sentinel/sud/usb/usbdaemon
#
# load_daemon : This starts and stops Rainbow Sentinel USB Daemon.
# 
# process-name: usbdaemon
#

progname="usbdaemon"

# check whether the executable file is present or not
[ -f "$USBDAEMON_INSTALL_DIR/$progname" ] || exit 1

OS="other"

if [ -f /etc/SuSE-release ]
then
OS="SuSE"
fi
if [ $OS == "SuSE" ]
then
	. /etc/rc.status
else
	#Function Library
        . /etc/init.d/functions
fi

#
# Create links to support old clients(older then ultrapro 1.0)
#
create_links()
{
	echo "Adding support for previous releases..."
	#create links for socket file to support clients earlier then SSP 7.0.0    
	rm -f /tmp/u.daemon > /dev/null 2>&1
	ln -s /var/run/sentinel/u.daemon  /tmp/u.daemon > /dev/null 2>&1 	
	if [ $? -eq 0 ]
	then
		chmod 666 /tmp/u.daemon > /dev/null 2>&1
		mkdir -p /opt/RainbowTechnologies/SUD5.5.0/USB > /dev/null 2>&1
		chmod 777 /opt/RainbowTechnologies/SUD5.5.0/USB > /dev/null 2>&1
		rm -f /opt/RainbowTechnologies/SUD5.5.0/USB/u.daemon  > /dev/null 2>&1
		ln -s /var/run/sentinel/u.daemon /opt/RainbowTechnologies/SUD5.5.0/USB/u.daemon > /dev/null 2>&1
		if [ $? -eq 0 ]
		then	
			chmod 666 /opt/RainbowTechnologies/SUD5.5.0/USB/u.daemon > /dev/null 2>&1
			echo "Done."
		else 
			echo "Failed."
		fi
	else
		echo "Failed."
    fi
}

#
# Remove Symbolic links created for supporting earlier versions
#
remove_links()
{
	if [ -L /tmp/u.daemon ] ; then
		rm -f /tmp/u.daemon  > /dev/null 2>&1
	fi
	if [ -L /opt/RainbowTechnologies/SUD5.5.0/USB/u.daemon ] ; then
		rm -f /opt/RainbowTechnologies/SUD5.5.0/USB/u.daemon   > /dev/null 2>&1
		ret=`ls /opt/RainbowTechnologies/SUD5.5.0/USB`
		if [ -z $ret ] ; then
			rm -rf /opt/RainbowTechnologies/SUD5.5.0/USB > /dev/null 2>&1
		fi
		ret=`ls /opt/RainbowTechnologies/SUD5.5.0`
		if [ -z $ret ] ; then
			rm -rf /opt/RainbowTechnologies/SUD5.5.0 > /dev/null 2>&1
		fi
		ret=`ls /opt/RainbowTechnologies`
		if [ -z $ret ] ; then
			rm -rf /opt/RainbowTechnologies > /dev/null 2>&1
		fi
	fi
}

#
# Start USB Daemon
#
start()
{
    echo -n $"Starting USB Daemon: "        
	mkdir -p /var/run/sentinel > /dev/null 2>&1
	chmod 777 /var/run/sentinel > /dev/null 2>&1

#Check the Distribution
cat /etc/issue |grep SuSE > /dev/null
                                                                                
#start daemon
if [ $? -eq 0 ]
then
   startproc $PROG_NAME -p /tmp/u.daemon_pid
   rc_status -v
else
        daemon $PROG_NAME
fi

	RETVAL=$?    
    
	#create links for socket file to support old clients
	create_links > /dev/null 2>&1
	chmod 666 /var/run/sentinel/u.daemon > /dev/null 2>&1
	echo
    return $RETVAL
}

#
# Stop USB Daemon
#
stop()
{
    echo -n $"Stopping USB Daemon: "
    #cd /opt/SafeNet\ Sentinel/SUD7.0.0/USB/

cd $USBDAEMON_INSTALL_DIR/
#Check the Distribution
cat /etc/issue |grep SuSE > /dev/null
                                                                                
if [ $? -eq 0 ]
then
   killproc $PROG_NAME
   rc_status -v
else
   killproc ./usbdaemon
        fi
    RETVAL=$?
    echo
	remove_links > /dev/null 2>&1    
    rm -rf /var/run/sentinel > /dev/null 2>&1    
    return $RETVAL
}

#
# Restart USN Daemon
#
restart(){
    stop    
    start
}


#
#  Start Here
#
case "$1" in
    start)
	start
	;;
    stop)
	stop
	;;
    status)
	#Check the Distribution
	cat /etc/issue |grep SuSE >/dev/null
	if [ $? -eq 0 ]
	then
	  checkproc $USBDAEMON_INSTALL_DIR/$progname
	  rc_status -v
	else
	  status $progname
	fi
	;;
    restart)
	restart
	;;
	support)
	create_links
	;;
    *)
	echo $"Usage: $0 {start|stop|status|restart|support}"
	RETVAL=1
esac

#Check the Distribution
cat /etc/issue |grep SuSE >/dev/null
if [ $? -eq 0 ]
then
rc_exit
fi
exit $RETVAL

